Index: branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/OPA_SRC/DOM/domhgr.F90
===================================================================
--- branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/OPA_SRC/DOM/domhgr.F90	(revision 7308)
+++ branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/OPA_SRC/DOM/domhgr.F90	(revision 7309)
@@ -38,5 +38,5 @@
 
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.7 , NEMO Consortium (2014)
+   !! NEMO/OPA 4.0 , NEMO Consortium (2011)
    !! $Id$ 
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -321,5 +321,75 @@
          e1v(:,:) =  ze1     ;      e2v(:,:) = ze1
          e1f(:,:) =  ze1     ;      e2f(:,:) = ze1
-         !
+
+      CASE ( 6 )                   ! clem: f-plane with irregular grid-spacing
+
+         IF(lwp) WRITE(numout,*)
+         IF(lwp) WRITE(numout,*) '          f-plane with irregular grid-spacing (+- 10%)'
+         IF(lwp) WRITE(numout,*) '          the max is given by ppe1_m and ppe2_m' 
+
+         ! Position coordinates (in kilometers)
+         !                          ==========
+         glam0 = 0._wp
+         gphi0 = 0._wp
+         
+#if defined key_agrif 
+         IF( .NOT. Agrif_Root() ) THEN
+            glam0  = Agrif_Parent(glam0) + (Agrif_ix())*Agrif_Parent(ppe1_m) * 1.e-5
+            gphi0  = Agrif_Parent(gphi0) + (Agrif_iy())*Agrif_Parent(ppe2_m) * 1.e-5
+            ppe1_m = Agrif_Parent(ppe1_m)/Agrif_Rhox()
+            ppe2_m = Agrif_Parent(ppe2_m)/Agrif_Rhoy()          
+         ENDIF
+#endif         
+
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               zti = FLOAT( ji - 1 + nimpp - 1 )         ;   ztj = FLOAT( jj - 1 + njmpp - 1 )
+               zui = FLOAT( ji - 1 + nimpp - 1 ) + 0.5   ;   zuj = FLOAT( jj - 1 + njmpp - 1 )
+               zvi = FLOAT( ji - 1 + nimpp - 1 )         ;   zvj = FLOAT( jj - 1 + njmpp - 1 ) + 0.5
+               zfi = FLOAT( ji - 1 + nimpp - 1 ) + 0.5   ;   zfj = FLOAT( jj - 1 + njmpp - 1 ) + 0.5
+
+               glamt(ji,jj) = glam0 + ppe1_m * 1.e-5 * zti
+               glamu(ji,jj) = glam0 + ppe1_m * 1.e-5 * zui
+               glamv(ji,jj) = glam0 + ppe1_m * 1.e-5 * zvi
+               glamf(ji,jj) = glam0 + ppe1_m * 1.e-5 * zfi
+   
+               gphit(ji,jj) = gphi0 + ppe2_m * 1.e-5 * ztj
+               gphiu(ji,jj) = gphi0 + ppe2_m * 1.e-5 * zuj
+               gphiv(ji,jj) = gphi0 + ppe2_m * 1.e-5 * zvj
+               gphif(ji,jj) = gphi0 + ppe2_m * 1.e-5 * zfj
+            END DO
+         END DO
+         
+         ! Horizontal scale factors (in meters)
+         !                              ======
+!! ==> EITHER 1) variable scale factors
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               !!e1t(ji,jj) = ppe1_m * EXP( -0.8/REAL(jpiglo**2) * (mi0(ji)-REAL(jpiglo+1)*0.5)**2 )  ! gaussian shape
+               !!e2t(ji,jj) = ppe2_m * EXP( -0.8/REAL(jpjglo**2) * (mj0(jj)-REAL(jpjglo+1)*0.5)**2 )  ! gaussian shape
+               e1t(ji,jj) = ppe1_m * ( 1. -0.1 * ABS(REAL(mi0(ji))-REAL(jpiglo+1)*0.5) / (1.-REAL(jpiglo+1)*0.5) ) ! linear shape
+               e2t(ji,jj) = ppe2_m * ( 1. -0.1 * ABS(REAL(mj0(jj))-REAL(jpjglo+1)*0.5) / (1.-REAL(jpjglo+1)*0.5) ) ! linear shape
+            END DO
+         END DO
+#if defined key_agrif 
+         IF( .NOT. Agrif_Root() ) THEN ! only works if the zoom is positioned at the center of the parent grid
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                  e1t(ji,jj) = ppe1_m * ( 1. -0.1 * ABS(REAL(mi0(ji))-REAL(jpiglo+1)*0.5) / (1.-REAL(jpiglo+1)*0.5)  &
+                     &                            * REAL(jpiglo) / REAL(Agrif_Parent(jpiglo) * Agrif_Rhox()) )       ! factor to match parent grid
+                  e2t(ji,jj) = ppe2_m * ( 1. -0.1 * ABS(REAL(mj0(jj))-REAL(jpjglo+1)*0.5) / (1.-REAL(jpjglo+1)*0.5)  &
+                     &                            * REAL(jpjglo) / REAL(Agrif_Parent(jpjglo) * Agrif_Rhoy()) )       ! factor to match parent grid
+               END DO
+            END DO
+         ENDIF
+#endif
+!! ==> OR 2) constant scale factors
+!!         e1t(:,:) = ppe1_m
+!!         e2t(:,:) = ppe2_m
+         
+         e1u(:,:) = e1t(:,:)      ;      e2u(:,:) = e2t(:,:)
+         e1v(:,:) = e1t(:,:)      ;      e2v(:,:) = e2t(:,:)
+         e1f(:,:) = e1t(:,:)      ;      e2f(:,:) = e2t(:,:)
+
       CASE DEFAULT
          WRITE(ctmp1,*) '          bad flag value for jphgr_msh = ', jphgr_msh
@@ -377,9 +447,11 @@
       CASE ( 0, 1, 4 )               ! mesh on the sphere
          !
-         ff(:,:) = 2. * omega * SIN( rad * gphif(:,:) ) 
+         ff  (:,:) = 2. * omega * SIN( rad * gphif(:,:) ) 
+         ff_t(:,:) = 2. * omega * SIN( rad * gphit(:,:) ) 
          !
       CASE ( 2 )                     ! f-plane at ppgphi0 
          !
-         ff(:,:) = 2. * omega * SIN( rad * ppgphi0 )
+         ff  (:,:) = 2. * omega * SIN( rad * ppgphi0 )
+         ff_t(:,:) = 2. * omega * SIN( rad * ppgphi0 )  ! clem: coriolis at T-point
          !
          IF(lwp) WRITE(numout,*) '          f-plane: Coriolis parameter = constant = ', ff(1,1)
@@ -399,5 +471,6 @@
          zf0     = 2. * omega * SIN( rad * zphi0 )                              ! compute f0 1st point south
          !
-         ff(:,:) = ( zf0  + zbeta * gphif(:,:) * 1.e+3 )                        ! f = f0 +beta* y ( y=0 at south)
+         ff  (:,:) = ( zf0  + zbeta * gphif(:,:) * 1.e+3 )                        ! f = f0 +beta* y ( y=0 at south)
+         ff_t(:,:) = ( zf0  + zbeta * gphit(:,:) * 1.e+3 )                        ! clem: coriolis at T-point
          !
          IF(lwp) THEN
@@ -420,5 +493,6 @@
          zf0   = 2. * omega * SIN( rad * zphi0 )                            ! compute f0 1st point south
          !
-         ff(:,:) = ( zf0 + zbeta * ABS( gphif(:,:) - zphi0 ) * rad * ra )   ! f = f0 +beta* y ( y=0 at south)
+         ff  (:,:) = ( zf0 + zbeta * ABS( gphif(:,:) - zphi0 ) * rad * ra )   ! f = f0 +beta* y ( y=0 at south)
+         ff_t(:,:) = ( zf0 + zbeta * ABS( gphit(:,:) - zphi0 ) * rad * ra )   ! clem: coriolis at T-point
          !
          IF(lwp) THEN
Index: branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/OPA_SRC/DOM/domzgr.F90
===================================================================
--- branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/OPA_SRC/DOM/domzgr.F90	(revision 7308)
+++ branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/OPA_SRC/DOM/domzgr.F90	(revision 7309)
@@ -145,4 +145,21 @@
       ! Build the vertical coordinate system
       ! ------------------------------------
+#if defined key_sas2D
+      WRITE(numout,*) ' domzgr: we use SAS2D (i.e. no ocean) with jpk=',jpk
+      mbathy(:,:) = 1   ;   bathy(:,:) = rn_hmin
+
+      gdept_0 (:,:,:) = rn_hmin
+      gdepw_0 (:,:,:) = rn_hmin   ;   gdep3w_0(:,:,:) = rn_hmin
+      gdept_1d(:)     = rn_hmin   ;   gdepw_1d(:)     = rn_hmin
+
+      e3t_0 (:,:,:) = rn_hmin
+      e3u_0 (:,:,:) = rn_hmin   ;   e3v_0 (:,:,:) = rn_hmin
+      e3f_0 (:,:,:) = rn_hmin   ;   e3w_0 (:,:,:) = rn_hmin
+      e3uw_0(:,:,:) = rn_hmin   ;   e3vw_0(:,:,:) = rn_hmin
+      e3t_1d(:)     = rn_hmin   ;   e3w_1d(:)     = rn_hmin
+
+      mikt(:,:) = 1   ;   mikv(:,:) = 1
+      miku(:,:) = 1   ;   mikf(:,:) = 1
+#else
                           CALL zgr_z            ! Reference z-coordinate system (always called)
                           CALL zgr_bat          ! Bathymetry fields (levels and meters)
@@ -164,4 +181,6 @@
       END IF
       !
+#endif
+      
       IF( nprint == 1 .AND. lwp )   THEN
          WRITE(numout,*) ' MIN val mbathy  ', MINVAL(  mbathy(:,:) ), ' MAX ', MAXVAL( mbathy(:,:) )
@@ -476,4 +495,6 @@
             idta( 1    , :    ) = 0                 ;      zdta( 1    , :    ) =  0._wp
             idta(jpidta, :    ) = 0                 ;      zdta(jpidta, :    ) =  0._wp
+         ELSEIF( jperio == 7 ) THEN
+!           Nothing to do here
          ELSE
             ih = 0                                  ;      zh = 0._wp
@@ -738,8 +759,8 @@
          IF( lk_mpp ) THEN
             IF( nbondi == -1 .OR. nbondi == 2 ) THEN
-               IF( jperio /= 1 )   mbathy(1,:) = 0
+               IF( jperio /= 1 .AND. jperio /= 7 )   mbathy(1,:) = 0
             ENDIF
             IF( nbondi == 1 .OR. nbondi == 2 ) THEN
-               IF( jperio /= 1 )   mbathy(nlci,:) = 0
+               IF( jperio /= 1 .AND. jperio /= 7 )   mbathy(nlci,:) = 0
             ENDIF
          ELSE
@@ -756,4 +777,9 @@
          mbathy( 1 ,:) = mbathy(jpim1,:)
          mbathy(jpi,:) = mbathy(  2  ,:)
+         IF (jperio == 7) THEN
+            IF(lwp) WRITE(numout,*)' north south boundary conditions on mbathy: jperio = ', jperio
+            mbathy( : ,1) = mbathy(:, jpjm1)
+            mbathy(:, jpj)= mbathy(:,2)
+         ENDIF
       ELSEIF( nperio == 2 ) THEN
          IF(lwp) WRITE(numout,*) '   equatorial boundary conditions on mbathy: nperio = ', nperio
Index: branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/OPA_SRC/IOM/iom.F90
===================================================================
--- branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/OPA_SRC/IOM/iom.F90	(revision 7308)
+++ branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/OPA_SRC/IOM/iom.F90	(revision 7309)
@@ -96,5 +96,5 @@
       CHARACTER(len=19) :: cldate 
       CHARACTER(len=10) :: clname
-      INTEGER           ::   ji
+      INTEGER           :: ji, jkmin
       !
       REAL(wp), ALLOCATABLE, DIMENSION(:,:) :: z_bnds
@@ -169,13 +169,14 @@
 
       ! Add vertical grid bounds
+      jkmin = MIN(2,jpk)  ! in case jpk=1 (i.e. sas2D)
       z_bnds(:      ,1) = gdepw_1d(:)
-      z_bnds(1:jpkm1,2) = gdepw_1d(2:jpk)
+      z_bnds(1:jpkm1,2) = gdepw_1d(jkmin:jpk)
       z_bnds(jpk:   ,2) = gdepw_1d(jpk) + e3t_1d(jpk)
       CALL iom_set_axis_attr( "deptht", bounds=z_bnds )
       CALL iom_set_axis_attr( "depthu", bounds=z_bnds )
       CALL iom_set_axis_attr( "depthv", bounds=z_bnds )
-      z_bnds(:    ,2) = gdept_1d(:)
-      z_bnds(2:jpk,1) = gdept_1d(1:jpkm1)
-      z_bnds(1    ,1) = gdept_1d(1) - e3w_1d(1)
+      z_bnds(:        ,2) = gdept_1d(:)
+      z_bnds(jkmin:jpk,1) = gdept_1d(1:jpkm1)
+      z_bnds(1        ,1) = gdept_1d(1) - e3w_1d(1)
       CALL iom_set_axis_attr( "depthw", bounds=z_bnds )
 
Index: branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/OPA_SRC/IOM/iom_def.F90
===================================================================
--- branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/OPA_SRC/IOM/iom_def.F90	(revision 7308)
+++ branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/OPA_SRC/IOM/iom_def.F90	(revision 7309)
@@ -39,6 +39,6 @@
    INTEGER, PARAMETER, PUBLIC ::   jp_i1    = 204      !: write INTEGER(1)
 
-   INTEGER, PARAMETER, PUBLIC ::   jpmax_files  = 100   !: maximum number of simultaneously opened file
-   INTEGER, PARAMETER, PUBLIC ::   jpmax_vars   = 600  !: maximum number of variables in one file
+   INTEGER, PARAMETER, PUBLIC ::   jpmax_files  = 100  !: maximum number of simultaneously opened file
+   INTEGER, PARAMETER, PUBLIC ::   jpmax_vars   = 1200 !: maximum number of variables in one file
    INTEGER, PARAMETER, PUBLIC ::   jpmax_dims   =  4   !: maximum number of dimensions for one variable
    INTEGER, PARAMETER, PUBLIC ::   jpmax_digits =  5   !: maximum number of digits for the cpu number in the file name
Index: branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/OPA_SRC/LBC/lib_mpp.F90
===================================================================
--- branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/OPA_SRC/LBC/lib_mpp.F90	(revision 7308)
+++ branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/OPA_SRC/LBC/lib_mpp.F90	(revision 7309)
@@ -405,7 +405,12 @@
                                          ptab(nlci-jpreci+1:jpi   ,:,:) = zland    ! north
          ENDIF
-         !                                   ! North-South boundaries (always closed)
-         IF( .NOT. cd_type == 'F' )   ptab(:,     1       :jprecj,:) = zland       ! south except F-point
-                                      ptab(:,nlcj-jprecj+1:jpj   ,:) = zland       ! north
+                                          ! North-south cyclic
+         IF ( nbondj == 2 .AND. jperio == 7 )    THEN !* cyclic north south only with no mpp split in latitude
+            ptab(:,1 , :) = ptab(:, jpjm1,:)
+            ptab(:,jpj,:) = ptab(:,     2,:)
+         ELSE   !                                   ! North-South boundaries (closed)
+            IF( .NOT. cd_type == 'F' )   ptab(:,     1       :jprecj,:) = zland       ! south except F-point
+                                         ptab(:,nlcj-jprecj+1:jpj   ,:) = zland       ! north
+         ENDIF
          !
       ENDIF
@@ -608,9 +613,15 @@
                                                    pt2d_array(ii)%pt2d(nlci-jpreci+1 : jpi   ,:) = zland    ! north
             ENDIF
-            !                                   ! North-South boundaries (always closed)
+                                                ! Noth-South boundaries
+            IF ( nbondj == 2 .AND. jperio == 7 )    THEN !* cyclic north south
+               pt2d_array(ii)%pt2d(:, 1   ) =   pt2d_array(ii)%pt2d(:, jpjm1 )
+               pt2d_array(ii)%pt2d(:, jpj ) =   pt2d_array(ii)%pt2d(:, 2 )          
+            ELSE   !             
+               !                                   ! North-South boundaries (closed)
                IF( .NOT. type_array(ii) == 'F' )   pt2d_array(ii)%pt2d(:,             1:jprecj ) = zland    ! south except F-point
                                                    pt2d_array(ii)%pt2d(:, nlcj-jprecj+1:jpj    ) = zland    ! north
             !
-         ENDIF
+            ENDIF
+          ENDIF
       END DO
 
@@ -888,8 +899,13 @@
                                          pt2d(nlci-jpreci+1:jpi   ,:) = zland    ! north
          ENDIF
-         !                                   ! North-South boundaries (always closed)
+                                            ! North-South boudaries
+         IF ( nbondj == 2 .AND. jperio == 7 )    THEN !* cyclic north south
+            pt2d(:,  1 ) = pt2d(:,jpjm1)
+            pt2d(:, jpj) = pt2d(:,    2)
+         ELSE    
+         !                                   ! North-South boundaries (closed)
             IF( .NOT. cd_type == 'F' )   pt2d(:,     1       :jprecj) = zland    !south except F-point
                                          pt2d(:,nlcj-jprecj+1:jpj   ) = zland    ! north
-         !
+         ENDIF     
       ENDIF
 
@@ -1071,12 +1087,17 @@
                                        ptab2(nlci-jpreci+1:jpi   ,:,:) = 0.e0
       ENDIF
-
-
-      !                                      ! North-South boundaries
+                                            ! North-South boundaries
+      IF ( nbondj == 2 .AND. jperio == 7 )    THEN !* cyclic north south
+         ptab1(:,     1       ,:) = ptab1(: ,  jpjm1 , :)
+         ptab1(:,   jpj       ,:) = ptab1(: ,      2 , :)
+         ptab2(:,     1       ,:) = ptab2(: ,  jpjm1 , :)
+         ptab2(:,   jpj       ,:) = ptab2(: ,      2 , :)
+      ELSE     
+      !                                      ! North-South boundaries closed
       IF( .NOT. cd_type1 == 'F' )   ptab1(:,     1       :jprecj,:) = 0.e0    ! south except at F-point
       IF( .NOT. cd_type2 == 'F' )   ptab2(:,     1       :jprecj,:) = 0.e0
                                     ptab1(:,nlcj-jprecj+1:jpj   ,:) = 0.e0    ! north
                                     ptab2(:,nlcj-jprecj+1:jpj   ,:) = 0.e0
-
+      ENDIF     
 
       ! 2. East and west directions exchange
@@ -1267,8 +1288,15 @@
       ! Order matters Here !!!!
       !
-      !                                      !* North-South boundaries (always colsed)
+                                           ! North-South cyclic
+      IF ( nbondj == 2 .AND. jperio == 7 )    THEN !* cyclic north south
+         pt2d(:, 1-jprj:  1     ) = pt2d ( :, jpjm1-jprj:jpjm1)
+         pt2d(:, jpj   :jpj+jprj) = pt2d ( :, 2         :2+jprj)
+      ELSE
+        
+      !                                      !* North-South boundaries (closed)
       IF( .NOT. cd_type == 'F' )   pt2d(:,  1-jprj   :  jprecj  ) = 0.e0    ! south except at F-point
                                    pt2d(:,nlcj-jprecj+1:jpj+jprj) = 0.e0    ! north
-
+      ENDIF
+                                
       !                                      ! East-West boundaries
       !                                           !* Cyclic east-west
Index: branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/OPA_SRC/LBC/mppini.F90
===================================================================
--- branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/OPA_SRC/LBC/mppini.F90	(revision 7308)
+++ branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/OPA_SRC/LBC/mppini.F90	(revision 7309)
@@ -76,4 +76,6 @@
           &              'the domain is lay out for distributed memory computing! ' )
 
+      IF( jperio == 7 ) CALL ctl_stop( ' jperio = 7 needs distributed memory computing ',   &
+          &              ' with 1 process. Add key_mpp_mpi in the list of active cpp keys ' )
    END SUBROUTINE mpp_init
 
@@ -379,5 +381,5 @@
       ! w a r n i n g  narea (zone) /= nproc (processors)!
 
-      IF( jperio == 1 .OR. jperio == 4 .OR. jperio == 6 ) THEN
+      IF( jperio == 1 .OR. jperio == 4 .OR. jperio == 6 .OR. jperio == 7 ) THEN
          IF( jpni == 1 )THEN
             nbondi = 2
@@ -446,4 +448,6 @@
       ENDIF
 
+      IF( jperio == 7 .AND. ( jpni /= 1 .OR. jpnj /= 1 ) ) &
+         &                  CALL ctl_stop( ' mpp_init: error jperio = 7 works only with jpni = jpnj = 1' )
       IF( nperio == 1 .AND. jpni /= 1 ) CALL ctl_stop( ' mpp_init: error on cyclicity' )
 
Index: branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/OPA_SRC/SBC/sbcana.F90
===================================================================
--- branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/OPA_SRC/SBC/sbcana.F90	(revision 7308)
+++ branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/OPA_SRC/SBC/sbcana.F90	(revision 7309)
@@ -4,6 +4,7 @@
    !! Ocean forcing:  analytical momentum, heat and freshwater forcings
    !!=====================================================================
-   !! History :  3.0   ! 2006-06  (G. Madec)  Original code
-   !!            3.2   ! 2009-07  (G. Madec)  Style only
+   !! History :  3.0   ! 2006-06  (G. Madec)    Original code
+   !!            3.2   ! 2009-07  (G. Madec)    Style only
+   !!            3.7   ! 2016-10  (C. Rousset)  Add analytic for LIM3 (ana_ice)
    !!----------------------------------------------------------------------
 
@@ -15,4 +16,5 @@
    USE dom_oce         ! ocean space and time domain
    USE sbc_oce         ! Surface boundary condition: ocean fields
+   USE sbc_ice         ! Surface boundary condition: ice   fields
    USE phycst          ! physical constants
    USE in_out_manager  ! I/O manager
@@ -20,19 +22,36 @@
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
    USE lib_fortran
-
+   USE wrk_nemo
+#if defined key_lim3
+   USE ice, ONLY       : pfrld, a_i_b
+   USE limthd_dh       ! for CALL lim_thd_snwblow
+#endif
+   
    IMPLICIT NONE
    PRIVATE
 
-   PUBLIC   sbc_ana    ! routine called in sbcmod module
-   PUBLIC   sbc_gyre   ! routine called in sbcmod module
+   PUBLIC   sbc_ana         ! routine called in sbcmod module
+   PUBLIC   sbc_gyre        ! routine called in sbcmod module
+#if defined key_lim3
+   PUBLIC   ana_ice_tau     ! routine called in sbc_ice_lim module
+   PUBLIC   ana_ice_flx     ! routine called in sbc_ice_lim module
+#endif
 
    !                       !!* Namelist namsbc_ana *
-   INTEGER  ::   nn_tau000  ! nb of time-step during which the surface stress
-   !                        ! increase from 0 to its nominal value 
-   REAL(wp) ::   rn_utau0   ! constant wind stress value in i-direction
-   REAL(wp) ::   rn_vtau0   ! constant wind stress value in j-direction
-   REAL(wp) ::   rn_qns0    ! non solar heat flux
-   REAL(wp) ::   rn_qsr0    !     solar heat flux
-   REAL(wp) ::   rn_emp0    ! net freshwater flux
+   ! --- oce variables --- !
+   INTEGER  ::   nn_tau000 ! nb of time-step during which the surface stress
+   !                       ! increase from 0 to its nominal value 
+   REAL(wp) ::   rn_utau0  ! constant wind stress value in i-direction
+   REAL(wp) ::   rn_vtau0  ! constant wind stress value in j-direction
+   REAL(wp) ::   rn_qns0   ! non solar heat flux
+   REAL(wp) ::   rn_qsr0   !     solar heat flux
+   REAL(wp) ::   rn_emp0   ! net freshwater flux
+   ! --- ice variables --- !
+   REAL(wp) ::   rn_iutau0 ! constant wind stress value in i-direction over ice
+   REAL(wp) ::   rn_ivtau0 ! constant wind stress value in j-direction over ice
+   REAL(wp) ::   rn_iqns0  ! non solar heat flux over ice
+   REAL(wp) ::   rn_iqsr0  !     solar heat flux over ice
+   REAL(wp) ::   rn_sprec0 ! snow precip
+   REAL(wp) ::   rn_ievap0 ! sublimation
    
    !! * Substitutions
@@ -68,5 +87,6 @@
       REAL(wp) ::   zcoef, zty, zmod      !   -      -
       !!
-      NAMELIST/namsbc_ana/ nn_tau000, rn_utau0, rn_vtau0, rn_qns0, rn_qsr0, rn_emp0
+      NAMELIST/namsbc_ana/ nn_tau000, rn_utau0, rn_vtau0, rn_qns0, rn_qsr0, rn_emp0,  &
+         &                 rn_iutau0, rn_ivtau0, rn_iqsr0, rn_iqns0, rn_sprec0, rn_ievap0
       !!---------------------------------------------------------------------
       !
@@ -85,10 +105,16 @@
          IF(lwp) WRITE(numout,*)' sbc_ana : Constant surface fluxes read in namsbc_ana namelist'
          IF(lwp) WRITE(numout,*)' ~~~~~~~ '
-         IF(lwp) WRITE(numout,*)'              spin up of the stress  nn_tau000 = ', nn_tau000, ' time-steps'
-         IF(lwp) WRITE(numout,*)'              constant i-stress      rn_utau0  = ', rn_utau0 , ' N/m2'
-         IF(lwp) WRITE(numout,*)'              constant j-stress      rn_vtau0  = ', rn_vtau0 , ' N/m2'
-         IF(lwp) WRITE(numout,*)'              non solar heat flux    rn_qns0   = ', rn_qns0  , ' W/m2'
-         IF(lwp) WRITE(numout,*)'              solar heat flux        rn_qsr0   = ', rn_qsr0  , ' W/m2'
-         IF(lwp) WRITE(numout,*)'              net heat flux          rn_emp0   = ', rn_emp0  , ' Kg/m2/s'
+         IF(lwp) WRITE(numout,*)'              spin up of the stress         nn_tau000 = ', nn_tau000 , ' time-steps'
+         IF(lwp) WRITE(numout,*)'              constant i-stress             rn_utau0  = ', rn_utau0  , ' N/m2'
+         IF(lwp) WRITE(numout,*)'              constant j-stress             rn_vtau0  = ', rn_vtau0  , ' N/m2'
+         IF(lwp) WRITE(numout,*)'              non solar heat flux           rn_qns0   = ', rn_qns0   , ' W/m2'
+         IF(lwp) WRITE(numout,*)'              solar heat flux               rn_qsr0   = ', rn_qsr0   , ' W/m2'
+         IF(lwp) WRITE(numout,*)'              net freshwater flux           rn_emp0   = ', rn_emp0   , ' Kg/m2/s'
+         IF(lwp) WRITE(numout,*)'              constant ice-atm stress       rn_iutau0 = ', rn_iutau0 , ' N/m2'
+         IF(lwp) WRITE(numout,*)'              constant ice-atm stress       rn_ivtau0 = ', rn_ivtau0 , ' N/m2'
+         IF(lwp) WRITE(numout,*)'              solar heat flux over ice      rn_iqsr0  = ', rn_iqsr0  , ' W/m2'
+         IF(lwp) WRITE(numout,*)'              non solar heat flux over ice  rn_iqns0  = ', rn_iqns0  , ' W/m2'
+         IF(lwp) WRITE(numout,*)'              snow precip                   rn_sprec0 = ', rn_sprec0 , ' Kg/m2/s'
+         IF(lwp) WRITE(numout,*)'              sublimation                   rn_ievap0 = ', rn_ievap0 , ' Kg/m2/s'
          !
          nn_tau000 = MAX( nn_tau000, 1 )     ! must be >= 1
@@ -132,5 +158,66 @@
    END SUBROUTINE sbc_ana
 
-
+#if defined key_lim3
+   SUBROUTINE ana_ice_tau
+      !!---------------------------------------------------------------------
+      !!                     ***  ROUTINE ana_ice_tau  ***
+      !!
+      !! ** Purpose :   provide the surface boundary (momentum) condition over sea-ice
+      !!---------------------------------------------------------------------
+      utau_ice(:,:) = rn_iutau0
+      vtau_ice(:,:) = rn_ivtau0
+     
+   END SUBROUTINE ana_ice_tau
+   
+   SUBROUTINE ana_ice_flx
+      !!---------------------------------------------------------------------
+      !!                     ***  ROUTINE ana_ice_flx  ***
+      !!
+      !! ** Purpose :   provide the surface boundary (flux) condition over sea-ice
+      !!---------------------------------------------------------------------
+      REAL(wp), DIMENSION(:,:), POINTER ::   zsnw       ! snw distribution after wind blowing
+      !!---------------------------------------------------------------------
+      CALL wrk_alloc( jpi,jpj, zsnw ) 
+
+      ! ocean variables (renaming)
+      emp_oce (:,:)   = rn_emp0
+      qsr_oce (:,:)   = rn_qsr0
+      qns_oce (:,:)   = rn_qns0
+      
+      ! ice variables
+      alb_ice (:,:,:) = 0.7_wp ! useless
+      qsr_ice (:,:,:) = rn_iqsr0
+      qns_ice (:,:,:) = rn_iqns0
+      sprecip (:,:)   = rn_sprec0
+      evap_ice(:,:,:) = rn_ievap0
+
+      ! ice variables deduced from above
+      zsnw(:,:) = 1._wp
+      !!CALL lim_thd_snwblow( pfrld, zsnw )  ! snow distribution over ice after wind blowing 
+      emp_ice  (:,:)   = SUM( a_i_b(:,:,:) * evap_ice(:,:,:), dim=3 ) - sprecip(:,:) * zsnw(:,:)
+      emp_oce  (:,:)   = emp_oce(:,:) - sprecip(:,:) * (1._wp - zsnw(:,:) )
+      qevap_ice(:,:,:) =   0._wp
+      qprec_ice(:,:)   =   rhosn * ( sst_m(:,:) * cpic - lfus ) * tmask(:,:,1) ! in J/m3
+      qemp_oce (:,:)   = - emp_oce(:,:) * sst_m(:,:) * rcp
+      qemp_ice (:,:)   =   sprecip(:,:) * zsnw * ( sst_m(:,:) * cpic - lfus ) * tmask(:,:,1) ! solid precip (only)
+
+      ! total fluxes
+      emp_tot (:,:) = emp_ice  + emp_oce 
+      qns_tot (:,:) = pfrld(:,:) * qns_oce(:,:) + SUM( a_i_b(:,:,:) * qns_ice(:,:,:), dim=3 ) + qemp_ice(:,:) + qemp_oce(:,:)
+      qsr_tot (:,:) = pfrld(:,:) * qsr_oce(:,:) + SUM( a_i_b(:,:,:) * qsr_ice(:,:,:), dim=3 )
+
+      !--------------------------------------------------------------------
+      ! FRACTIONs of net shortwave radiation which is not absorbed in the
+      ! thin surface layer and penetrates inside the ice cover
+      ! ( Maykut and Untersteiner, 1971 ; Ebert and Curry, 1993 )
+      fr1_i0(:,:) = ( 0.18 * ( 1.0 - cldf_ice ) + 0.35 * cldf_ice )
+      fr2_i0(:,:) = ( 0.82 * ( 1.0 - cldf_ice ) + 0.65 * cldf_ice )
+
+      CALL wrk_dealloc( jpi,jpj, zsnw ) 
+      
+   END SUBROUTINE ana_ice_flx
+#endif
+
+   
    SUBROUTINE sbc_gyre( kt )
       !!---------------------------------------------------------------------
